## Read data
SAdata   <- as.matrix(read.csv("Incidence.csv", header = TRUE))

S <- matrix(0, nrow = nrow(SAdata), ncol = 24)
S[, 1: 6] <- SAdata[, 7:12]
S[, 7:12] <- SAdata[,14:19]
S[,13:18] <- SAdata[,37:42]
S[,19:24] <- SAdata[,51:56]

W <- matrix(0, nrow = nrow(SAdata), ncol = 13)
W[, 1: 6] <- SAdata[, 1: 6]
W[, 7:13] <- SAdata[,20:26]

Tid <- matrix(0, nrow = nrow(SAdata), ncol = 9)
Tid[, 1: 9] <- SAdata[,27:35]


result <- matrix(0, nrow = 1000, ncol = 7)
  for(i in 1:1000){
    Ss       <- matrix(0, nrow = nrow(SAdata), ncol = 3)
    Ss[,1:3] <- S[,sample(1:24,3)]
    Ssum     <- as.matrix(rowSums(Ss))
    Ssum     <- ifelse(Ssum==0, 0, 1)
    
    Ws       <- matrix(0, nrow = nrow(SAdata), ncol = 3)
    Ws[,1:3] <- W[,sample(1:13,3)]
    Wsum     <- as.matrix(rowSums(Ws))
    Wsum     <- ifelse(Wsum==0, 0, 1)
    
    Tids       <- matrix(0, nrow = nrow(SAdata), ncol = 7)
    Tids[,1:7] <- Tid[,sample(1:9,7)]
    Tsum       <- as.matrix(rowSums(Tids))
    Tsum       <- ifelse(Tsum==0, 0, 1)

    vsS   <- ifelse((Wsum + Tsum)==0, 0, 1)
    vsW   <- ifelse((Ssum + Tsum)==0, 0, 1)
    vsT   <- ifelse((Ssum + Wsum)==0, 0, 1)
    
    Share <- ifelse((Ssum + Wsum + Tsum)==3, 1, 0)
    UniS  <- ifelse((Ssum - vsS)==1, 1, 0)
    UniW  <- ifelse((Wsum - vsW)==1, 1, 0)
    UniT  <- ifelse((Tsum - vsT)==1, 1, 0)

    Share.SW <- ifelse((Ssum + Wsum)==2, 1, 0)
    Share.ST <- ifelse((Ssum + Tsum)==2, 1, 0)
    Share.WT <- ifelse((Wsum + Tsum)==2, 1, 0)
    
    N.Share    <- sum(Share)
    N.Share.SW <- sum(Share.SW)
    N.Share.ST <- sum(Share.ST)
    N.Share.WT <- sum(Share.WT)
    N.UniS     <- sum(UniS)
    N.UniW     <- sum(UniW)
    N.UniT     <- sum(UniT)
    
    J.SW <- N.Share.SW/(sum(Ssum) + sum(Wsum) - N.Share.SW)
    J.ST <- N.Share.ST/(sum(Ssum) + sum(Tsum) - N.Share.ST)
    J.WT <- N.Share.WT/(sum(Wsum) + sum(Tsum) - N.Share.WT)
    
    result[i,1] <- N.Share
    result[i,2] <- N.UniS
    result[i,3] <- N.UniW
    result[i,4] <- N.UniT
    result[i,5] <- J.SW
    result[i,6] <- J.ST
    result[i,7] <- J.WT
  }
  FSname <- paste("Comp_SA_result",".csv")
  write.table(result, file = FSname, sep=",")  


Ssum  <- as.matrix(rowSums(S))
Ssum  <- ifelse(Ssum==0, 0, 1)
Wsum  <- as.matrix(rowSums(W))
Wsum  <- ifelse(Wsum==0, 0, 1)
Tsum  <- as.matrix(rowSums(Tid))
Tsum  <- ifelse(Tsum==0, 0, 1)

vsS   <- ifelse((Wsum + Tsum)==0, 0, 1)
vsW   <- ifelse((Ssum + Tsum)==0, 0, 1)
vsT   <- ifelse((Ssum + Wsum)==0, 0, 1)

Share <- ifelse((Ssum + Wsum + Tsum)==3, 1, 0)
UniS  <- ifelse((Ssum - vsS)==1, 1, 0)
UniW  <- ifelse((Wsum - vsW)==1, 1, 0)
UniT  <- ifelse((Tsum - vsT)==1, 1, 0)

sum(Share)
sum(UniS)
sum(UniW)
sum(UniT)